#include <Wire.h>
// I2C address of the module
#include <LiquidCrystal.h>
#define  ADDRESS 0x51

// Control and status registers
#define  CTRL_STAT1  0x00
#define  CTRL_STAT2  0x01

// Time and date registers
#define  SECONDS     0x02
#define  MINUTES     0x03
#define  HOURS       0x04
#define  DAYS        0x05
#define  WEEKDAYS    0x06
#define  MONTHS      0x07
#define  YEARS       0x08

// Alarm registers
#define  AMINUTES    0x09
#define  AHOURS      0x0A
#define  ADAYS       0x0B
#define  AWEEKDAYS   0x0C

//CLKOUT control register
#define  CLKOUT_CTRL 0x0D

// Timer registers
#define  TIMER_CTRL  0x0E
#define  TIMER       0x0F

/* initialize the library objects */
/* LiquidCrystal lcd(rs, en, d4, d5, d6, d7); */
LiquidCrystal lcd(8 , 9 , 5 , 4 , 7 , 6);

//void setupADC(){
int ff(){
  
 ADMUX = 0;
 ADMUX |= (1 << REFS1);  //Internal 2.56V Voltage Reference with external capacitor on AREF pin
 ADMUX |= (1 << REFS0);  //Internal 2.56V Voltage Reference with external capacitor on AREF pin
 ADMUX |= (0 << ADLAR);  //Temperature Sensor - 100111
  ADMUX |= (0 << MUX3);  //Temperature Sensor - 100111
  ADMUX |= (0 << MUX2);  //Temperature Sensor - 100111
  ADMUX |= (0 << MUX1);  //Temperature Sensor - 100111
  ADMUX |= (1 << MUX0);  //Temperature Sensor - 100111

  //ADC Control and Status Register A 
  ADCSRA = 0;
  ADCSRA |= (1 << ADEN);  //Enable the ADC
  ADCSRA |= (1 << ADPS2);  //ADC Prescaler - 16 (16MHz -> 1MHz)
  ADCSRA |= (1 << ADPS1);  //ADC Prescaler - 16 (16MHz -> 1MHz)
 ADCSRA |= (0 << ADPS0);  //ADC Prescaler - 16 (16MHz -> 1MHz)
  //ADC Control and Status Register B 
 // ADCSRB = 0;
  //ADCSRB |= (1 << MUX5);  //Temperature Sensor - 100111
 
//  delay(10);
  delay(10);
  
  
 ADCSRA |= (1 << ADSC);  //Start temperature conversion
 while (bit_is_set(ADCSRA, ADSC));  //Wait for conversion to finish
 byte low  = ADCL;
byte high = ADCH;
ADCL = 0;
ADCH = 0;
int ff = (high << 8) | low;  //Result is in kelvin
// return gett;// - 273 + TEMP_OFFSET;
 //return (229.5-0.459*gett);
//ADCSRA = 0;
 return (ff);
}
float gett(){
  
 ADMUX = 0;
 ADMUX |= (1 << REFS1);  //Internal 2.56V Voltage Reference with external capacitor on AREF pin
 ADMUX |= (1 << REFS0);  //Internal 2.56V Voltage Reference with external capacitor on AREF pin
 ADMUX |= (0 << ADLAR);  //Temperature Sensor - 100111
  ADMUX |= (0 << MUX3);  //Temperature Sensor - 100111
  ADMUX |= (0 << MUX2);  //Temperature Sensor - 100111
  ADMUX |= (0 << MUX1);  //Temperature Sensor - 100111
  ADMUX |= (0 << MUX0);  //Temperature Sensor - 100111

  //ADC Control and Status Register A 
  ADCSRA = 0;
  ADCSRA |= (1 << ADEN);  //Enable the ADC
  ADCSRA |= (1 << ADPS2);  //ADC Prescaler - 16 (16MHz -> 1MHz)
  ADCSRA |= (1 << ADPS1);  //ADC Prescaler - 16 (16MHz -> 1MHz)
 ADCSRA |= (0 << ADPS0);  //ADC Prescaler - 16 (16MHz -> 1MHz)
  //ADC Control and Status Register B 
 // ADCSRB = 0;
  //ADCSRB |= (1 << MUX5);  //Temperature Sensor - 100111
 
//  delay(10);
  delay(10);
  
  
 ADCSRA |= (1 << ADSC);  //Start temperature conversion
 while (bit_is_set(ADCSRA, ADSC));  //Wait for conversion to finish
 byte low  = ADCL;
byte high = ADCH;
ADCL = 0;
ADCH = 0;
int gett = (high << 8) | low;  //Result is in kelvin
// return gett;// - 273 + TEMP_OFFSET;
 return (229.5-0.459*gett);
//ADCSRA = 0;
 //return (gett);
}


unsigned char Data[16];
char Buff[32];

int Mask[16] =
{
  0xFF,  // 0
  0xFF,  // 1
  0x7F,  // 2
  0x7F,  // 3
  0x3F,  // 4
  0x3F,  // 5
  0x07,  // 6
  0x1F,  // 7
  0xFF,  // 8
  0x7F,  // 9
  0x3F,  // 10
  0x3F,  // 11
  0x07,  // 12
  0x03,  // 13
  0x03,  // 14
  0xFF,  // 15
};

char Word[16][14] =
{
  "CTRL STAT1",  // 0
  "CTRL STAT2",  // 1
  "Seconds",  // 2
  "Minutes",  // 3
  "Hours",  // 4
  "Days",  // 5
  "Weekdays",  // 6
  "Months",  // 7
  "Years",  // 8
  "Alarm Minute",  // 9
  "Alarm Hour",  // 10
  "Alarm Day",  // 11
  "Alarm Weekday",  // 12
  "CLCKOUT CTRL",  // 13
  "Timer CTRL",  // 14
  "Timer",  // 15
};

char WeekDays[7][10] =
{
  "Sunday",
  "Monday",
  "Tuesday",
  "Wednesday",
  "Thurdsday",
  "Friday",
  "Saturday"
};

int BCD_to_Int (int Input)
{
  return (Input>>4)*10+(Input&0x0F);
}

int Int_to_BCD (int Input)
{
  return ((Input/10)<<4) | (Input%10);
}

long int ReadNumber (void)
{
  long int Number=0, Negative_Flag = 1;
  char c;
  while (1)
  {
    if (Serial.available () > 0)
      c = Serial.read ();
    else
      continue;
    if (c == '-')
    {
      Negative_Flag = -1;
      continue;
    }
    if ((c == 10) || (c == 13))
      break;
    Number = Number * 10 + (c - '0');
  }
  return Number*Negative_Flag;
}

void I2C_Send (unsigned char Address, unsigned char Register, unsigned char Data)
{
  unsigned char Temp[2] = {Register, Data};
  Wire.beginTransmission (Address);
  Wire.write (Temp, 2);
  Wire.endTransmission ();
}

void I2C_Receive (unsigned char Address, unsigned char Register, unsigned char Data[], unsigned char NumOfBytes)
{
  int i=0;
  Wire.beginTransmission (Address);
  Wire.write (&Register, 1);
  Wire.endTransmission ();

  Wire.requestFrom(Address, NumOfBytes);
  
  while(Wire.available())    // slave may send less than requested
    Data[i++] = Wire.read(); // receive a byte as character
  return;
}

void Set_Registers (void)
{
  int Register, Value, i;
  Serial.print ('\f');

  for (i=0; i<16; i++)
  {
    sprintf (Buff, "%d. %s", i, Word[i]);
    Serial.println (Buff);
  }

  Serial.print ("Register: ");
  Register = ReadNumber ();
  Serial.println (Register);
  Serial.print ("Value: ");
  Value = ReadNumber ();
  Serial.println (Value);

  // NOTE!!!: here we write the actual data not the BCD!!!
  I2C_Send (ADDRESS, Register, Value);

  return;
}

void Set_Date_Time (void)
{
  int Value;
  Serial.print ("\n\fSet the date & time");
  
  Serial.print ("\n\rInput year: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, YEARS, Int_to_BCD(Value));
  
  Serial.print ("\nInput month: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, MONTHS, Int_to_BCD(Value));
  
  Serial.print ("\nInput day: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, DAYS, Int_to_BCD(Value));
  
  Serial.print ("\nInput weekday: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, WEEKDAYS, Int_to_BCD(Value));
  
  Serial.print ("\nInput hour: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, HOURS, Int_to_BCD(Value));
  
  Serial.print ("\nInput minute: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, MINUTES, Int_to_BCD(Value));
  
  Serial.print ("\nInput second: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, SECONDS, Int_to_BCD(Value));
  
  Serial.print ('\f');
  return;
}

void Set_Alarm (void)
{
  int Value;
  Serial.print ("\n\fSet the alarm");
  
  Serial.print ("\n\rInput hour: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, AHOURS, Int_to_BCD(Value));
  
  Serial.print ("\nInput minute: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, AMINUTES, Int_to_BCD(Value));
  
  Serial.print ("\nInput day: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, ADAYS, Int_to_BCD(Value));
  
  Serial.print ("\nInput weekday: ");
  Value = ReadNumber ();
  I2C_Send (ADDRESS, AWEEKDAYS, Int_to_BCD(Value));
  
  Serial.print ("\f");
  return;
}

void setup()
{
  pinMode (2, INPUT);
  Serial.begin (9600);
  Wire.begin ();
  delay (100);
   lcd.begin(16, 2);
}

void loop()
{
  static int prev=0;
  int i;
  long int Timeout;
  lcd.setCursor(0, 0);
  // Trigger changing data & time or alarm time.
  // if the button is pressed
  if (!digitalRead (2))
  {
    delay (10);
    Timeout=300000;
    // check if it (the button) is held for ~1 second
    while ((!digitalRead(2)) && Timeout)
      Timeout--;
    
    if (Timeout)  // if just pressed but not held
      Set_Date_Time ();
    else          // if held (timeout = 0)
      Set_Alarm ();
  }

  // Reading data
  I2C_Receive (ADDRESS, 0, Data, 16);  // we get all the data (from register 0 to 15 --> 16 registers)
  
  // Check if a different data has arrived (basically if the seconds are different)
  if (Data[2] == prev)
    return;
  else
    prev = Data[2];

  // New century check - the flag is the 7th bit of the Months data
  if (Data[MONTHS] & 0x80)
  {
    Serial.println ("\n\rNew Century!");
    I2C_Send (ADDRESS, MONTHS, Data[MONTHS] & (~0x80));  // clear the flag
    delay (2000);
  }

  // Alarm check - the flag is the 3th bit of the CTRL_STAT2 register
  if (Data[CTRL_STAT2] & 0x08)
  {
    Serial.println ("\n\rAlarm!");
    I2C_Send (ADDRESS, CTRL_STAT2, Data[CTRL_STAT2] & (~0x08));  // clear the flag
    delay (2000);
  }

  // Printing the current date and time
  for (i=2; i<=8; i++)
    Data[i] = BCD_to_Int(Data[i] & Mask[i]);
    lcd.print(Data[8]);
  lcd.print(" ");
  lcd.print(Data[7]);
  lcd.print(" ");
  lcd.print(Data[5]);
  lcd.print(" ");
  lcd.print(Data[6]);
  sprintf (Buff, "\n\f%.2d/%.2d/%.2d (%s) %.2d:%.2d:%.2d", Data[5], Data[7], Data[8], WeekDays[Data[6]], Data[4], Data[3], Data[2]);
  Serial.print (Buff);
  lcd.print(" ");
  lcd.print(ff());
  lcd.print(" ");
  lcd.print(" ");
  lcd.setCursor(0, 1);
   lcd.print(Data[4]);
  lcd.print(" ");
  lcd.print(Data[3]);
  lcd.print(" ");
  lcd.print(Data[2]);
  lcd.print(" ");
   lcd.print(gett());
  
}
